var beanpole = require('beanpole'),
vine = require('vine');



beanpole.require(['hook.core','hook.socket.io.client']);


var todos = [],
currentId = 0;

todos.push({ _id: currentId++, label: 'clean the garage', done: false });
todos.push({ _id: currentId++, label: 'go to the grocery store', done: false });

function findTodoItem(id, callback)
{
	for(var i = todos.length; i--;)
	{
		if(todos[i]._id == id)
		{
			var item = todos[i];
			return callback(item, i);
		}
	}

	return callback();
}


beanpole.on({
	
	/**
	 */

	'pull -public todos': function()
	{
		return vine.list(todos).end();
	},


	/**
	 */

	'pull -public -method=POST todos' : function(request)
	{
		var todo = { _id: currentId++, label: request.data.label, done: false };
			
		todos.push(todo);

		return vine.result(todo).end(request);
	},

	/**
	 */

	'pull -public todos/:id' : function(request)
	{
		findTodoItem(this.data.id, function(item, index)
		{
			return vine.result(item).end(request);
		});
	},


	/**
	 */

	'pull -public -method=PUT todos/:id' : function(request)
	{
		findTodoItem(this.data.id, function(item, index)
		{
			for(var prop in request.data)
			{
				item[prop] = request.data[prop];	
			}

			vine.result(todos[request.data.id]).end(request);
		});
	},

	/**
	 */

	'pull -public -method=DELETE todos/:id' : function(request)
	{
		findTodoItem(this.data.id, function(item, index)
		{
			if(item) todos.splice(index, 1);

			vine.result(item).end(request);
		});

	}
});

beanpole.push('ready','spice.io');

beanpole.push('init');